version: 1.0.{build}

image: Visual Studio 2022
services:
  - mssql2017

branches:
  only:
    - staging
    - master

clone_depth: 1

stack: node 18.16

dotnet_csproj:
  patch: true
  file: '**\*.csproj'
  version: '{version}'
  package_version: '{version}'
  assembly_version: '{version}'
  file_version: '{version}'
  informational_version: '{version}'

before_build:
  - npm install -g gulp
  - npm install -g yarn
  - ps: Remove-Item -Path src\Web\web.config
  - ps: Move-Item -Path src\Web\web.$env:APPVEYOR_REPO_BRANCH.config -Destination src\Web\web.config
  - cd %APPVEYOR_BUILD_FOLDER%\src\Web
  - yarn install

build_script:
  - dotnet --version
  - cd %APPVEYOR_BUILD_FOLDER%\tests\Tests.Common
  - mv -f appsettings.appveyor.json appsettings.json
  - cd %APPVEYOR_BUILD_FOLDER%\src\Web
  - gulp prod
  - cd %APPVEYOR_BUILD_FOLDER%\src\Web\vue-app
  - cp -f .env.master .env
  - yarn install
  - yarn build
  - cd %APPVEYOR_BUILD_FOLDER%\src\Web
  - dotnet publish .\ -o __publish -c Release
  - 7z a .\Web.zip .\__publish\* .\__publish\**\*
  - cd ..\..

test_script:
  - dotnet build
  - dotnet test --no-build .\tests\Tests.Infrastructure
  - dotnet test --no-build .\tests\Tests.Application
  - dotnet test --no-build .\tests\Tests.Domain\
  - dotnet test --no-build .\tests\Tests.Web\

artifacts:
  - path: ./src/Web/__publish
    name: jardins-entente.web

deploy:
  - provider: Environment
    name: jardin-entente-env
    website: JardinEntente
    aspnet_core: true
    aspnet_core_force_restart: true
    app_offline: true
    remove_files: true
    skip_dirs: \\App_Data;\\.well-known;
    on:
      branch: master